<?php
/**
 *    SmilePay 金流中心-Ecmall付款模組
 *    @author    Hank,Hsu
 *    @date    2014/3/20
 */
class smilepay_711c2cPayment extends BasePayment
{
    /* smilepay api */
    var $_gateway   =   'https://ssl.smse.com.tw/ezpos/mtmk_utf.asp';
    var $_code      =   'smilepay_711c2c';
    
    
    function get_payform($order_info)
    {
       
        /* 商店代號 */
        $Dcvc = $this->_config['smilepay_711c2c_Dcvc'];
        $Rvg2c = $this->_config['smilepay_711c2c_Rvg2c'];		  
        /* 檢查碼 */
 		    $Verifykey = $this->_config['smilepay_711c2c_Verifykey'];
        /* 繳款期限 */
 		    $LimitDay = $this->_config['smilepay_711c2c_LimitDay'];
         
         			
        /* 商品名称 可註解*/
        //$Od_sob = $this->_get_subject($order_info);
        
        /* 總金额 */
        $Amount = $order_info['order_amount'] ;           
        $Data_id = $this->_get_trade_sn($order_info);    
	       /*買家email*/
        $email = $order_info['buyer_email'] ;	
        /* 返回的路径 */
		    $bk_posturl =$this->_create_notify_url($order_info['order_id']);  //付款結果回傳位址		 
        $roturl    = $this->_create_return_url($order_info['order_id']);   //付款完成導向地址
        
        $db = &db(); //讀取商品資料
        $sql = 'select goods_id,goods_name,price,quantity from '.DB_PREFIX.'order_goods where order_id='.$order_info['order_id'];
        $params_order = $db->getAll($sql);
                        
         //$db = &db(); //讀取寄件地址
         $sql = 'select consignee,phone_mob,phone_tel from '.DB_PREFIX.'order_extm where order_id='.$order_info['order_id'];
         $params_addresss = $db->getAll($sql);
        
        $params = array(
            'Dcvc' => $Dcvc,                                 
            'Rvg2c' => $Rvg2c,     
            'Pay_zg'=> '41',
            'Data_id' => $Data_id,
            'Od_sob' => mb_substr( $params_order[0]['goods_name'],0,20,"utf-8"),
            'Amount' => round($Amount),
            'Pur_name' => mb_substr($params_addresss[0]['consignee'],0,5,"utf-8"),
            'Mobile_number' => mb_substr($params_addresss[0]['phone_tel'],0,10,"utf-8"),
            'Tel_number' => mb_substr($params_addresss[0]['phone_mob'],0,10,"utf-8"),              
            'Email' => $email,
            'Pay_gdry' => 'TW',          
            'Verify_key' => $Verifykey,
            'Roturl' => $bk_posturl,                
            'MapRoturl' => $bk_posturl."&type=mapurl",            
            'Roturl_status' => "ecamll",
            
        );
    
       return $this->_create_payform('GET', $params);
      
    }
    
    /**
     *    返回通知结果
     * 
     */ 
    function verify_notify($order_info, $strict = false)
    { 
      
  	  if (empty($order_info)){  	   
  			$this->_error('order_info_empty');
  			return false;
  		}
  	/*--START顯示c2c結單資訊,取貨付款,並修改狀態為已付款完成--*/  
  		 if ( $_REQUEST['type']=="StoreInfo"){
  		    parse_str(urldecode($_REQUEST[parms]), $notify);  		     
          $html_template=	'<script type="text/javascript">window.onload = function () {  
          var htmlsp = "<h4><br><font color=red>7-11超商取貨付款訂單</h4><font color=blue>'.$notify['Data_id'].'</font> 訂單取件門市資訊：</font><br>收件人： <font color=blue>'.$notify['Pur_name'].'</font><br>收件人電話: <font color=blue>'.$notify['Mobile_number'].'</font><br>取件門市：<font color=blue>'.$notify['Storename'].'</font><br>取件門市地址：<font color=blue>'.$notify['Storeaddress'].'</font><br>付款金額：<font color=blue>'.abs($notify['Amount']).'</font><br><font color=red>***收到取貨通知簡訊，請於7日內至取件門市完成取貨付款！**</font>"; 
          $(".succeed").html(htmlsp);}</script>';             
          echo $html_template;
           return array(
               'target'    =>  ORDER_FINISHED,
          );   
       }
      /*--END顯示c2c結單資訊,取貨付款--*/        		

           
      
  		/*--START繳款通知--*/
           	 
  		if($_REQUEST['Amount'] >0 && $_REQUEST['act']=="notify" ) {
         $Classif= $_REQUEST['Classif'];
         $Data_id= $_REQUEST['Data_id'];
         $Amount =  $_REQUEST['Amount'];    
         $Smseid       = $_REQUEST['Smseid'];
         $Mid_smilepay =  $_REQUEST['Mid_smilepay'];
        
        /*--START MAPURL接收，更變狀態付款完成，並再轉頁至  **顯示c2c結單資訊,取貨付款,並修改狀態為已付款完成** --*/  
        if ( $_REQUEST['Storeid']!="" && $_REQUEST['type']=="mapurl"){           
       	$roturl    = $this->_create_return_url($order_info['order_id']);   //MAP完成再次導向地址
          $parms = array(
              'Status=' .$_REQUEST['Status'],                                 
              'Classif='. $_REQUEST['Classif'],     
              'Data_id='.$_REQUEST['Data_id'],
              'Smseid=' . $_REQUEST['Smseid'],
              'Pur_name='.$_REQUEST['Pur_name'],
              'Mobile_number='.$_REQUEST['Mobile_number'],
              'Storeid='.$_REQUEST['Storeid'],
              'Storename='.$_REQUEST['Storename'],
              'Storeaddress='.$_REQUEST['Storeaddress'],              
              'Amount='.$_REQUEST['Amount'],  
              
          );
          $_REQUEST['StoreInfo']= $roturl."&type=StoreInfo&parms=".urlencode(implode("&",$parms));  		    
          //將狀態改完付款成功
          return array(
               'target'    =>  ORDER_ACCEPTED,
          );
       }
       /*--END   SMAPURL接收-*/   
             
         //是否啟用商家驗證參數
         $i_Mid = $this->_config['smilepay_711c2c_i_Mid'];
         $Mid = $this->_config['smilepay_711c2c_Mid'];
  			 if($i_Mid=="yes" ){
             if(!$this->midfun($Mid,$Amount,$Smseid,$Mid_smilepay)){      
                  $this->_error('sign_inconsistent');                  
  			          return false;
             }     
         }                                                       		   
  		    // 通知中的订单与欲改变的订单不一致 	
         if ($order_info['out_trade_sn'] != $Data_id){            		     
            $this->_error('order_inconsistent');
            return false;
         }
         // 支付的金额与实际金额不一致 
    		 if (abs($order_info['order_amount']) != abs($Amount)){  		      
            $this->_error('price_inconsistent');
            return false;
         }         
         // 支付的金额与实际金额相符,付款類別相符 ,修改狀態為已完成收貨訂單代表商品已取貨 
    		 if ((abs($order_info['order_amount']) == abs($Amount)) && $Classif=="T"  ){            
            return array(
               'target'    =>  ORDER_FINISHED ,
            );
         }else{         
            $this->_error('sign_inconsistent');            
            return false;
         }
           
    	}else{           
           return false;
      }
      /*--END繳款通知--*/  
      
	}
	
    function verify_result($result) { 
	       
      if ($result){
         echo "ecmall";
         
         if($_REQUEST['type']=="mapurl"){         
            header('Location:'.$_REQUEST['StoreInfo']);            
            exit;              
         }
      }else{
           echo "fail";
      }
        	 
    }

   // compute Mid  (設定值,金額,追碼,post值)    
  function midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay){   
    $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
    $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
    $dtotal=$Mid_value. $Amount. $Smseid;                              
    
    $i = 1;
    $sum = strlen($dtotal);
    $etemp=0;      
    while ($i <= $sum)
    {
      $ep = substr($dtotal,$i,1);
      $etemp = $etemp + $ep;                
      $i=$i+2;
    }                
    
    $i = 0;  
    $otemp=0;          
    while ($i <= $sum)
    {                                              
      $op = substr($dtotal,$i,1);
      $otemp = $otemp + $op;
      $i=$i+2;
    } 
    
    $mid=($etemp*3)+($otemp*9);
  
    if($Mid_smilepay == $mid){
      return true;
    }else{
      return false;
    }       
  }  
        
}
?>